/* Notification.c generated by valac 0.52.4, the Vala compiler
 * generated from Notification.vala, do not modify */

/*
* Copyright 2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
*/

#include <glib-object.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define NOTIFICATIONS_TYPE_NOTIFICATION (notifications_notification_get_type ())
#define NOTIFICATIONS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification))
#define NOTIFICATIONS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotificationClass))
#define NOTIFICATIONS_IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOTIFICATIONS_TYPE_NOTIFICATION))
#define NOTIFICATIONS_IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOTIFICATIONS_TYPE_NOTIFICATION))
#define NOTIFICATIONS_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotificationClass))

typedef struct _NotificationsNotification NotificationsNotification;
typedef struct _NotificationsNotificationClass NotificationsNotificationClass;
typedef struct _NotificationsNotificationPrivate NotificationsNotificationPrivate;

#define NOTIFICATIONS_TYPE_MASKED_IMAGE (notifications_masked_image_get_type ())
#define NOTIFICATIONS_MASKED_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOTIFICATIONS_TYPE_MASKED_IMAGE, NotificationsMaskedImage))
#define NOTIFICATIONS_MASKED_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOTIFICATIONS_TYPE_MASKED_IMAGE, NotificationsMaskedImageClass))
#define NOTIFICATIONS_IS_MASKED_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOTIFICATIONS_TYPE_MASKED_IMAGE))
#define NOTIFICATIONS_IS_MASKED_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOTIFICATIONS_TYPE_MASKED_IMAGE))
#define NOTIFICATIONS_MASKED_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOTIFICATIONS_TYPE_MASKED_IMAGE, NotificationsMaskedImageClass))

typedef struct _NotificationsMaskedImage NotificationsMaskedImage;
typedef struct _NotificationsMaskedImageClass NotificationsMaskedImageClass;
enum  {
	NOTIFICATIONS_NOTIFICATION_0_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_APP_INFO_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_PRIORITY_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_HINTS_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_ACTIONS_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_APP_ICON_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_APP_ID_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_APP_NAME_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_BODY_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_SUMMARY_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_PRIMARY_ICON_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_IMAGE_PROPERTY,
	NOTIFICATIONS_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _NotificationsNotification {
	GObject parent_instance;
	NotificationsNotificationPrivate * priv;
};

struct _NotificationsNotificationClass {
	GObjectClass parent_class;
};

struct _NotificationsNotificationPrivate {
	GDesktopAppInfo* _app_info;
	GNotificationPriority _priority;
	GHashTable* _hints;
	gchar** _actions;
	gint _actions_length1;
	gint __actions_size_;
	gchar* _app_icon;
	gchar* _app_id;
	gchar* _app_name;
	gchar* _body;
	gchar* _summary;
	GIcon* _primary_icon;
	GIcon* _badge_icon;
	NotificationsMaskedImage* _image;
};

static gint NotificationsNotification_private_offset;
static gpointer notifications_notification_parent_class = NULL;
static GRegex* notifications_notification_entity_regex;
static GRegex* notifications_notification_entity_regex = NULL;
static GRegex* notifications_notification_tag_regex;
static GRegex* notifications_notification_tag_regex = NULL;

GType notifications_notification_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotificationsNotification, g_object_unref)
GType notifications_masked_image_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotificationsMaskedImage, g_object_unref)
#define NOTIFICATIONS_NOTIFICATION_OTHER_APP_ID "gala-other"
NotificationsNotification* notifications_notification_new (const gchar* app_name,
                                                           const gchar* app_icon,
                                                           const gchar* summary,
                                                           const gchar* body,
                                                           gchar** actions,
                                                           gint actions_length1,
                                                           GHashTable* hints);
NotificationsNotification* notifications_notification_construct (GType object_type,
                                                                 const gchar* app_name,
                                                                 const gchar* app_icon,
                                                                 const gchar* summary,
                                                                 const gchar* body,
                                                                 gchar** actions,
                                                                 gint actions_length1,
                                                                 GHashTable* hints);
static gchar* notifications_notification_fix_markup (NotificationsNotification* self,
                                              const gchar* markup);
static GdkPixbuf* notifications_notification_image_data_variant_to_pixbuf (NotificationsNotification* self,
                                                                    GVariant* img);
GDesktopAppInfo* notifications_notification_get_app_info (NotificationsNotification* self);
static void notifications_notification_set_app_info (NotificationsNotification* self,
                                              GDesktopAppInfo* value);
GNotificationPriority notifications_notification_get_priority (NotificationsNotification* self);
static void notifications_notification_set_priority (NotificationsNotification* self,
                                              GNotificationPriority value);
GHashTable* notifications_notification_get_hints (NotificationsNotification* self);
static void notifications_notification_set_hints (NotificationsNotification* self,
                                           GHashTable* value);
gchar** notifications_notification_get_actions (NotificationsNotification* self,
                                                gint* result_length1);
static void notifications_notification_set_actions (NotificationsNotification* self,
                                             gchar** value,
                                             gint value_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          gint length);
const gchar* notifications_notification_get_app_icon (NotificationsNotification* self);
static void notifications_notification_set_app_icon (NotificationsNotification* self,
                                              const gchar* value);
const gchar* notifications_notification_get_app_id (NotificationsNotification* self);
static void notifications_notification_set_app_id (NotificationsNotification* self,
                                            const gchar* value);
const gchar* notifications_notification_get_app_name (NotificationsNotification* self);
static void notifications_notification_set_app_name (NotificationsNotification* self,
                                              const gchar* value);
const gchar* notifications_notification_get_body (NotificationsNotification* self);
void notifications_notification_set_body (NotificationsNotification* self,
                                          const gchar* value);
const gchar* notifications_notification_get_summary (NotificationsNotification* self);
void notifications_notification_set_summary (NotificationsNotification* self,
                                             const gchar* value);
GIcon* notifications_notification_get_primary_icon (NotificationsNotification* self);
void notifications_notification_set_primary_icon (NotificationsNotification* self,
                                                  GIcon* value);
GIcon* notifications_notification_get_badge_icon (NotificationsNotification* self);
void notifications_notification_set_badge_icon (NotificationsNotification* self,
                                                GIcon* value);
NotificationsMaskedImage* notifications_notification_get_image (NotificationsNotification* self);
void notifications_notification_set_image (NotificationsNotification* self,
                                           NotificationsMaskedImage* value);
static GObject * notifications_notification_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
NotificationsMaskedImage* notifications_masked_image_new (GdkPixbuf* pixbuf);
NotificationsMaskedImage* notifications_masked_image_construct (GType object_type,
                                                                GdkPixbuf* pixbuf);
static void notifications_notification_finalize (GObject * obj);
static GType notifications_notification_get_type_once (void);
static void _vala_notifications_notification_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_notifications_notification_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
notifications_notification_get_instance_private (NotificationsNotification* self)
{
	return G_STRUCT_MEMBER_P (self, NotificationsNotification_private_offset);
}

NotificationsNotification*
notifications_notification_construct (GType object_type,
                                      const gchar* app_name,
                                      const gchar* app_icon,
                                      const gchar* summary,
                                      const gchar* body,
                                      gchar** actions,
                                      gint actions_length1,
                                      GHashTable* hints)
{
	NotificationsNotification * self = NULL;
	g_return_val_if_fail (app_name != NULL, NULL);
	g_return_val_if_fail (app_icon != NULL, NULL);
	g_return_val_if_fail (summary != NULL, NULL);
	g_return_val_if_fail (body != NULL, NULL);
	g_return_val_if_fail (hints != NULL, NULL);
	self = (NotificationsNotification*) g_object_new (object_type, "app-name", app_name, "app-icon", app_icon, "summary", summary, "body", body, "actions", actions, "hints", hints, NULL);
	return self;
}

NotificationsNotification*
notifications_notification_new (const gchar* app_name,
                                const gchar* app_icon,
                                const gchar* summary,
                                const gchar* body,
                                gchar** actions,
                                gint actions_length1,
                                GHashTable* hints)
{
	return notifications_notification_construct (NOTIFICATIONS_TYPE_NOTIFICATION, app_name, app_icon, summary, body, actions, actions_length1, hints);
}

/**
     * Copied from gnome-shell, fixes the mess of markup that is sent to us
     */
static gchar*
notifications_notification_fix_markup (NotificationsNotification* self,
                                       const gchar* markup)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (markup != NULL, NULL);
	_tmp0_ = g_strdup (markup);
	text = _tmp0_;
	{
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp2_ = notifications_notification_entity_regex;
		_tmp3_ = strlen (markup);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_replace (_tmp2_, markup, (gssize) _tmp4_, 0, "&amp;", 0, &_inner_error0_);
		_tmp1_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp6_ = _tmp1_;
		_tmp1_ = NULL;
		_g_free0 (text);
		text = _tmp6_;
		_tmp8_ = notifications_notification_tag_regex;
		_tmp9_ = text;
		_tmp10_ = text;
		_tmp11_ = strlen (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_regex_replace (_tmp8_, _tmp9_, (gssize) _tmp12_, 0, "&lt;", 0, &_inner_error0_);
		_tmp7_ = _tmp13_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			goto __catch0_g_error;
		}
		_tmp14_ = _tmp7_;
		_tmp7_ = NULL;
		_g_free0 (text);
		text = _tmp14_;
		_g_free0 (_tmp7_);
		_g_free0 (_tmp1_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp15_ = e;
		_tmp16_ = _tmp15_->message;
		g_warning ("Notification.vala:144: Invalid regex: %s", _tmp16_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (text);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = text;
	return result;
}

static GdkPixbuf*
notifications_notification_image_data_variant_to_pixbuf (NotificationsNotification* self,
                                                         GVariant* img)
{
	const gchar* _tmp0_;
	gint width = 0;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gint _tmp4_;
	gint height = 0;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	gint _tmp7_;
	gint rowstride = 0;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	gint _tmp10_;
	gboolean has_alpha = FALSE;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	gboolean _tmp13_;
	gint bits_per_sample = 0;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	gint _tmp16_;
	guint8* raw = NULL;
	GVariant* _tmp17_;
	GVariant* _tmp18_;
	void* _tmp19_;
	guint8* _tmp20_;
	gint _tmp20__length1;
	gint raw_length1;
	gint _raw_size_;
	GdkPixbuf* pixbuf = NULL;
	guint8* _tmp21_;
	gint _tmp21__length1;
	GdkPixbuf* _tmp22_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (img != NULL, NULL);
	_tmp0_ = g_variant_get_type_string (img);
	if (g_strcmp0 (_tmp0_, "(iiibiiay)") != 0) {
		const gchar* _tmp1_;
		_tmp1_ = g_variant_get_type_string (img);
		g_warning ("Notification.vala:152: Invalid type string: %s", _tmp1_);
		result = NULL;
		return result;
	}
	_tmp2_ = g_variant_get_child_value (img, (gsize) 0);
	_tmp3_ = _tmp2_;
	_tmp4_ = (gint) g_variant_get_int32 (_tmp3_);
	_g_variant_unref0 (_tmp3_);
	width = _tmp4_;
	_tmp5_ = g_variant_get_child_value (img, (gsize) 1);
	_tmp6_ = _tmp5_;
	_tmp7_ = (gint) g_variant_get_int32 (_tmp6_);
	_g_variant_unref0 (_tmp6_);
	height = _tmp7_;
	_tmp8_ = g_variant_get_child_value (img, (gsize) 2);
	_tmp9_ = _tmp8_;
	_tmp10_ = (gint) g_variant_get_int32 (_tmp9_);
	_g_variant_unref0 (_tmp9_);
	rowstride = _tmp10_;
	_tmp11_ = g_variant_get_child_value (img, (gsize) 3);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_variant_get_boolean (_tmp12_);
	_g_variant_unref0 (_tmp12_);
	has_alpha = _tmp13_;
	_tmp14_ = g_variant_get_child_value (img, (gsize) 4);
	_tmp15_ = _tmp14_;
	_tmp16_ = (gint) g_variant_get_int32 (_tmp15_);
	_g_variant_unref0 (_tmp15_);
	bits_per_sample = _tmp16_;
	_tmp17_ = g_variant_get_child_value (img, (gsize) 6);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_variant_get_data (_tmp18_);
	_tmp20_ = (guint8*) _tmp19_;
	_tmp20__length1 = -1;
	_g_variant_unref0 (_tmp18_);
	raw = _tmp20_;
	raw_length1 = _tmp20__length1;
	_raw_size_ = raw_length1;
	_tmp21_ = raw;
	_tmp21__length1 = raw_length1;
	_tmp22_ = gdk_pixbuf_new_from_data (_tmp21_, GDK_COLORSPACE_RGB, has_alpha, bits_per_sample, width, height, rowstride, (GdkPixbufDestroyNotify) NULL, NULL);
	pixbuf = _tmp22_;
	_tmp23_ = pixbuf;
	_tmp24_ = gdk_pixbuf_copy (_tmp23_);
	result = _tmp24_;
	_g_object_unref0 (pixbuf);
	return result;
}

GDesktopAppInfo*
notifications_notification_get_app_info (NotificationsNotification* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_info;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
notifications_notification_set_app_info (NotificationsNotification* self,
                                         GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_app_info (self);
	if (old_value != value) {
		GDesktopAppInfo* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_app_info);
		self->priv->_app_info = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_APP_INFO_PROPERTY]);
	}
}

GNotificationPriority
notifications_notification_get_priority (NotificationsNotification* self)
{
	GNotificationPriority result;
	GNotificationPriority _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_priority;
	result = _tmp0_;
	return result;
}

static void
notifications_notification_set_priority (NotificationsNotification* self,
                                         GNotificationPriority value)
{
	GNotificationPriority old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_priority (self);
	if (old_value != value) {
		self->priv->_priority = value;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_PRIORITY_PROPERTY]);
	}
}

GHashTable*
notifications_notification_get_hints (NotificationsNotification* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_hints;
	result = _tmp0_;
	return result;
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

static void
notifications_notification_set_hints (NotificationsNotification* self,
                                      GHashTable* value)
{
	GHashTable* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_hints (self);
	if (old_value != value) {
		GHashTable* _tmp0_;
		_tmp0_ = _g_hash_table_ref0 (value);
		_g_hash_table_unref0 (self->priv->_hints);
		self->priv->_hints = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_HINTS_PROPERTY]);
	}
}

gchar**
notifications_notification_get_actions (NotificationsNotification* self,
                                        gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_actions;
	_tmp0__length1 = self->priv->_actions_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gint length)
{
	if (length >= 0) {
		gchar** result;
		gint i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
notifications_notification_set_actions (NotificationsNotification* self,
                                        gchar** value,
                                        gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_actions (self, &old_value_length);
	if (old_value != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : value;
		_tmp0__length1 = value_length1;
		self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_actions = _tmp0_;
		self->priv->_actions_length1 = _tmp0__length1;
		self->priv->__actions_size_ = self->priv->_actions_length1;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_ACTIONS_PROPERTY]);
	}
}

const gchar*
notifications_notification_get_app_icon (NotificationsNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_icon;
	result = _tmp0_;
	return result;
}

static void
notifications_notification_set_app_icon (NotificationsNotification* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_app_icon (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_app_icon);
		self->priv->_app_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_APP_ICON_PROPERTY]);
	}
}

const gchar*
notifications_notification_get_app_id (NotificationsNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_id;
	result = _tmp0_;
	return result;
}

static void
notifications_notification_set_app_id (NotificationsNotification* self,
                                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_app_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_app_id);
		self->priv->_app_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_APP_ID_PROPERTY]);
	}
}

const gchar*
notifications_notification_get_app_name (NotificationsNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_name;
	result = _tmp0_;
	return result;
}

static void
notifications_notification_set_app_name (NotificationsNotification* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_app_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_app_name);
		self->priv->_app_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_APP_NAME_PROPERTY]);
	}
}

const gchar*
notifications_notification_get_body (NotificationsNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_body;
	result = _tmp0_;
	return result;
}

void
notifications_notification_set_body (NotificationsNotification* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_body (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_body);
		self->priv->_body = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_BODY_PROPERTY]);
	}
}

const gchar*
notifications_notification_get_summary (NotificationsNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_summary;
	result = _tmp0_;
	return result;
}

void
notifications_notification_set_summary (NotificationsNotification* self,
                                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_summary (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_summary);
		self->priv->_summary = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_SUMMARY_PROPERTY]);
	}
}

GIcon*
notifications_notification_get_primary_icon (NotificationsNotification* self)
{
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_primary_icon;
	result = _tmp0_;
	return result;
}

void
notifications_notification_set_primary_icon (NotificationsNotification* self,
                                             GIcon* value)
{
	GIcon* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_primary_icon (self);
	if (old_value != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_primary_icon);
		self->priv->_primary_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_PRIMARY_ICON_PROPERTY]);
	}
}

GIcon*
notifications_notification_get_badge_icon (NotificationsNotification* self)
{
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_badge_icon;
	result = _tmp0_;
	return result;
}

void
notifications_notification_set_badge_icon (NotificationsNotification* self,
                                           GIcon* value)
{
	GIcon* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_badge_icon (self);
	if (old_value != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_badge_icon);
		self->priv->_badge_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY]);
	}
}

NotificationsMaskedImage*
notifications_notification_get_image (NotificationsNotification* self)
{
	NotificationsMaskedImage* result;
	NotificationsMaskedImage* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_image;
	result = _tmp0_;
	return result;
}

void
notifications_notification_set_image (NotificationsNotification* self,
                                      NotificationsMaskedImage* value)
{
	NotificationsMaskedImage* old_value;
	g_return_if_fail (self != NULL);
	old_value = notifications_notification_get_image (self);
	if (old_value != value) {
		NotificationsMaskedImage* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_image);
		self->priv->_image = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_IMAGE_PROPERTY]);
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static GObject *
notifications_notification_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NotificationsNotification * self;
	GVariant* variant = NULL;
	gboolean _tmp0_ = FALSE;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
	GVariant* _tmp3_;
	gboolean _tmp7_ = FALSE;
	GHashTable* _tmp8_;
	gconstpointer _tmp9_;
	GVariant* _tmp10_;
	gboolean _tmp29_ = FALSE;
	const gchar* _tmp30_;
	gboolean _tmp41_ = FALSE;
	GHashTable* _tmp42_;
	gconstpointer _tmp43_;
	GVariant* _tmp44_;
	gboolean _tmp69_ = FALSE;
	gboolean _tmp70_ = FALSE;
	GHashTable* _tmp71_;
	gconstpointer _tmp72_;
	GVariant* _tmp73_;
	gboolean _tmp86_ = FALSE;
	NotificationsMaskedImage* _tmp87_;
	gboolean _tmp91_ = FALSE;
	const gchar* _tmp92_;
	const gchar* _tmp96_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (notifications_notification_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification);
	variant = NULL;
	_tmp1_ = self->priv->_hints;
	_tmp2_ = g_hash_table_lookup (_tmp1_, "urgency");
	variant = (GVariant*) _tmp2_;
	_tmp3_ = variant;
	if (_tmp3_ != NULL) {
		GVariant* _tmp4_;
		const GVariantType* _tmp5_;
		_tmp4_ = variant;
		_tmp5_ = G_VARIANT_TYPE_BYTE;
		_tmp0_ = g_variant_is_of_type (_tmp4_, _tmp5_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GVariant* _tmp6_;
		_tmp6_ = variant;
		notifications_notification_set_priority (self, (GNotificationPriority) g_variant_get_byte (_tmp6_));
	}
	_tmp8_ = self->priv->_hints;
	_tmp9_ = g_hash_table_lookup (_tmp8_, "desktop-entry");
	variant = (GVariant*) _tmp9_;
	_tmp10_ = variant;
	if (_tmp10_ != NULL) {
		GVariant* _tmp11_;
		const GVariantType* _tmp12_;
		_tmp11_ = variant;
		_tmp12_ = G_VARIANT_TYPE_STRING;
		_tmp7_ = g_variant_is_of_type (_tmp11_, _tmp12_);
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		GVariant* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GDesktopAppInfo* _tmp21_;
		GDesktopAppInfo* _tmp22_;
		GDesktopAppInfo* _tmp23_;
		_tmp13_ = variant;
		_tmp14_ = g_variant_get_string (_tmp13_, NULL);
		notifications_notification_set_app_id (self, _tmp14_);
		_tmp15_ = self->priv->_app_id;
		_tmp16_ = string_replace (_tmp15_, ".desktop", "");
		_tmp17_ = _tmp16_;
		_g_free0 (_tmp17_);
		_tmp18_ = self->priv->_app_id;
		_tmp19_ = g_strdup_printf ("%s.desktop", _tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_desktop_app_info_new (_tmp20_);
		_tmp22_ = _tmp21_;
		notifications_notification_set_app_info (self, _tmp22_);
		_g_object_unref0 (_tmp22_);
		_g_free0 (_tmp20_);
		_tmp23_ = self->priv->_app_info;
		if (_tmp23_ == NULL) {
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			GDesktopAppInfo* _tmp27_;
			GDesktopAppInfo* _tmp28_;
			_tmp24_ = self->priv->_app_id;
			_tmp25_ = g_strdup_printf ("/etc/xdg/autostart/%s.desktop", _tmp24_);
			_tmp26_ = _tmp25_;
			_tmp27_ = g_desktop_app_info_new_from_filename (_tmp26_);
			_tmp28_ = _tmp27_;
			notifications_notification_set_app_info (self, _tmp28_);
			_g_object_unref0 (_tmp28_);
			_g_free0 (_tmp26_);
		}
	}
	_tmp30_ = self->priv->_app_icon;
	if (g_strcmp0 (_tmp30_, "") == 0) {
		GDesktopAppInfo* _tmp31_;
		_tmp31_ = self->priv->_app_info;
		_tmp29_ = _tmp31_ != NULL;
	} else {
		_tmp29_ = FALSE;
	}
	if (_tmp29_) {
		GDesktopAppInfo* _tmp32_;
		GIcon* _tmp33_;
		_tmp32_ = self->priv->_app_info;
		_tmp33_ = g_app_info_get_icon ((GAppInfo*) _tmp32_);
		notifications_notification_set_primary_icon (self, _tmp33_);
	} else {
		const gchar* _tmp34_;
		_tmp34_ = self->priv->_app_icon;
		if (string_contains (_tmp34_, "/")) {
			GFile* file = NULL;
			const gchar* _tmp35_;
			GFile* _tmp36_;
			GFile* _tmp37_;
			_tmp35_ = self->priv->_app_icon;
			_tmp36_ = g_file_new_for_uri (_tmp35_);
			file = _tmp36_;
			_tmp37_ = file;
			if (g_file_query_exists (_tmp37_, NULL)) {
				GFile* _tmp38_;
				GFileIcon* _tmp39_;
				GFileIcon* _tmp40_;
				_tmp38_ = file;
				_tmp39_ = (GFileIcon*) g_file_icon_new (_tmp38_);
				_tmp40_ = _tmp39_;
				notifications_notification_set_primary_icon (self, (GIcon*) _tmp40_);
				_g_object_unref0 (_tmp40_);
			}
			_g_object_unref0 (file);
		}
	}
	_tmp42_ = self->priv->_hints;
	_tmp43_ = g_hash_table_lookup (_tmp42_, "image-path");
	variant = (GVariant*) _tmp43_;
	_tmp44_ = variant;
	if (_tmp44_ != NULL) {
		_tmp41_ = TRUE;
	} else {
		GHashTable* _tmp45_;
		gconstpointer _tmp46_;
		GVariant* _tmp47_;
		_tmp45_ = self->priv->_hints;
		_tmp46_ = g_hash_table_lookup (_tmp45_, "image_path");
		variant = (GVariant*) _tmp46_;
		_tmp47_ = variant;
		_tmp41_ = _tmp47_ != NULL;
	}
	if (_tmp41_) {
		gchar* image_path = NULL;
		GVariant* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gboolean _tmp51_ = FALSE;
		GtkIconTheme* _tmp52_;
		const gchar* _tmp53_;
		_tmp48_ = variant;
		_tmp49_ = g_variant_get_string (_tmp48_, NULL);
		_tmp50_ = g_strdup (_tmp49_);
		image_path = _tmp50_;
		_tmp52_ = gtk_icon_theme_get_default ();
		_tmp53_ = image_path;
		if (gtk_icon_theme_has_icon (_tmp52_, _tmp53_)) {
			const gchar* _tmp54_;
			const gchar* _tmp55_;
			_tmp54_ = image_path;
			_tmp55_ = self->priv->_app_icon;
			_tmp51_ = g_strcmp0 (_tmp54_, _tmp55_) != 0;
		} else {
			_tmp51_ = FALSE;
		}
		if (_tmp51_) {
			const gchar* _tmp56_;
			GThemedIcon* _tmp57_;
			GThemedIcon* _tmp58_;
			_tmp56_ = image_path;
			_tmp57_ = (GThemedIcon*) g_themed_icon_new (_tmp56_);
			_tmp58_ = _tmp57_;
			notifications_notification_set_badge_icon (self, (GIcon*) _tmp58_);
			_g_object_unref0 (_tmp58_);
		} else {
			gboolean _tmp59_ = FALSE;
			const gchar* _tmp60_;
			_tmp60_ = image_path;
			if (g_str_has_prefix (_tmp60_, "/")) {
				_tmp59_ = TRUE;
			} else {
				const gchar* _tmp61_;
				_tmp61_ = image_path;
				_tmp59_ = g_str_has_prefix (_tmp61_, "file://");
			}
			if (_tmp59_) {
				{
					GdkPixbuf* pixbuf = NULL;
					const gchar* _tmp62_;
					GdkPixbuf* _tmp63_;
					GdkPixbuf* _tmp64_;
					NotificationsMaskedImage* _tmp65_;
					NotificationsMaskedImage* _tmp66_;
					_tmp62_ = image_path;
					_tmp63_ = gdk_pixbuf_new_from_file (_tmp62_, &_inner_error0_);
					pixbuf = _tmp63_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp64_ = pixbuf;
					_tmp65_ = notifications_masked_image_new (_tmp64_);
					g_object_ref_sink (_tmp65_);
					_tmp66_ = _tmp65_;
					notifications_notification_set_image (self, _tmp66_);
					_g_object_unref0 (_tmp66_);
					_g_object_unref0 (pixbuf);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp67_;
					const gchar* _tmp68_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp67_ = e;
					_tmp68_ = _tmp67_->message;
					g_critical ("Notification.vala:101: Unable to mask image: %s", _tmp68_);
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_free0 (image_path);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
				}
			}
		}
		_g_free0 (image_path);
	}
	_tmp71_ = self->priv->_hints;
	_tmp72_ = g_hash_table_lookup (_tmp71_, "image-data");
	variant = (GVariant*) _tmp72_;
	_tmp73_ = variant;
	if (_tmp73_ != NULL) {
		_tmp70_ = TRUE;
	} else {
		GHashTable* _tmp74_;
		gconstpointer _tmp75_;
		GVariant* _tmp76_;
		_tmp74_ = self->priv->_hints;
		_tmp75_ = g_hash_table_lookup (_tmp74_, "image_data");
		variant = (GVariant*) _tmp75_;
		_tmp76_ = variant;
		_tmp70_ = _tmp76_ != NULL;
	}
	if (_tmp70_) {
		_tmp69_ = TRUE;
	} else {
		GHashTable* _tmp77_;
		gconstpointer _tmp78_;
		GVariant* _tmp79_;
		_tmp77_ = self->priv->_hints;
		_tmp78_ = g_hash_table_lookup (_tmp77_, "icon_data");
		variant = (GVariant*) _tmp78_;
		_tmp79_ = variant;
		_tmp69_ = _tmp79_ != NULL;
	}
	if (_tmp69_) {
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp80_;
		GdkPixbuf* _tmp81_;
		GdkPixbuf* _tmp82_;
		_tmp80_ = variant;
		_tmp81_ = notifications_notification_image_data_variant_to_pixbuf (self, _tmp80_);
		pixbuf = _tmp81_;
		_tmp82_ = pixbuf;
		if (_tmp82_ != NULL) {
			GdkPixbuf* _tmp83_;
			NotificationsMaskedImage* _tmp84_;
			NotificationsMaskedImage* _tmp85_;
			_tmp83_ = pixbuf;
			_tmp84_ = notifications_masked_image_new (_tmp83_);
			g_object_ref_sink (_tmp84_);
			_tmp85_ = _tmp84_;
			notifications_notification_set_image (self, _tmp85_);
			_g_object_unref0 (_tmp85_);
		}
		_g_object_unref0 (pixbuf);
	}
	_tmp87_ = self->priv->_image;
	if (_tmp87_ == NULL) {
		GIcon* _tmp88_;
		_tmp88_ = self->priv->_primary_icon;
		_tmp86_ = _tmp88_ == NULL;
	} else {
		_tmp86_ = FALSE;
	}
	if (_tmp86_) {
		GThemedIcon* _tmp89_;
		GThemedIcon* _tmp90_;
		_tmp89_ = (GThemedIcon*) g_themed_icon_new ("dialog-information");
		_tmp90_ = _tmp89_;
		notifications_notification_set_primary_icon (self, (GIcon*) _tmp90_);
		_g_object_unref0 (_tmp90_);
	}
	_tmp92_ = self->priv->_app_name;
	if (g_strcmp0 (_tmp92_, "") == 0) {
		GDesktopAppInfo* _tmp93_;
		_tmp93_ = self->priv->_app_info;
		_tmp91_ = _tmp93_ != NULL;
	} else {
		_tmp91_ = FALSE;
	}
	if (_tmp91_) {
		GDesktopAppInfo* _tmp94_;
		const gchar* _tmp95_;
		_tmp94_ = self->priv->_app_info;
		_tmp95_ = g_app_info_get_display_name ((GAppInfo*) _tmp94_);
		notifications_notification_set_app_name (self, _tmp95_);
	}
	_tmp96_ = self->priv->_body;
	if (g_strcmp0 (_tmp96_, "") == 0) {
		const gchar* _tmp97_;
		gchar* _tmp98_;
		gchar* _tmp99_;
		const gchar* _tmp100_;
		_tmp97_ = self->priv->_summary;
		_tmp98_ = notifications_notification_fix_markup (self, _tmp97_);
		_tmp99_ = _tmp98_;
		notifications_notification_set_body (self, _tmp99_);
		_g_free0 (_tmp99_);
		_tmp100_ = self->priv->_app_name;
		notifications_notification_set_summary (self, _tmp100_);
	} else {
		const gchar* _tmp101_;
		gchar* _tmp102_;
		gchar* _tmp103_;
		const gchar* _tmp104_;
		gchar* _tmp105_;
		gchar* _tmp106_;
		_tmp101_ = self->priv->_body;
		_tmp102_ = notifications_notification_fix_markup (self, _tmp101_);
		_tmp103_ = _tmp102_;
		notifications_notification_set_body (self, _tmp103_);
		_g_free0 (_tmp103_);
		_tmp104_ = self->priv->_summary;
		_tmp105_ = notifications_notification_fix_markup (self, _tmp104_);
		_tmp106_ = _tmp105_;
		notifications_notification_set_summary (self, _tmp106_);
		_g_free0 (_tmp106_);
	}
	return obj;
}

static void
notifications_notification_class_init (NotificationsNotificationClass * klass,
                                       gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
	notifications_notification_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NotificationsNotification_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_notifications_notification_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_notifications_notification_set_property;
	G_OBJECT_CLASS (klass)->constructor = notifications_notification_constructor;
	G_OBJECT_CLASS (klass)->finalize = notifications_notification_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_APP_INFO_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_PRIORITY_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_PRIORITY_PROPERTY] = g_param_spec_enum ("priority", "priority", "priority", g_notification_priority_get_type (), G_NOTIFICATION_PRIORITY_NORMAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_HINTS_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_HINTS_PROPERTY] = g_param_spec_boxed ("hints", "hints", "hints", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_ACTIONS_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_ACTIONS_PROPERTY] = g_param_spec_boxed ("actions", "actions", "actions", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_APP_ICON_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_APP_ICON_PROPERTY] = g_param_spec_string ("app-icon", "app-icon", "app-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_APP_ID_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_APP_NAME_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_BODY_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_BODY_PROPERTY] = g_param_spec_string ("body", "body", "body", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_SUMMARY_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_SUMMARY_PROPERTY] = g_param_spec_string ("summary", "summary", "summary", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_PRIMARY_ICON_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_PRIMARY_ICON_PROPERTY] = g_param_spec_object ("primary-icon", "primary-icon", "primary-icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY] = g_param_spec_object ("badge-icon", "badge-icon", "badge-icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFICATIONS_NOTIFICATION_IMAGE_PROPERTY, notifications_notification_properties[NOTIFICATIONS_NOTIFICATION_IMAGE_PROPERTY] = g_param_spec_object ("image", "image", "image", NOTIFICATIONS_TYPE_MASKED_IMAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
		_tmp1_ = g_regex_new ("&(?!amp;|quot;|apos;|lt;|gt;)", 0, 0, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_regex_unref0 (notifications_notification_entity_regex);
		notifications_notification_entity_regex = _tmp2_;
		_tmp4_ = g_regex_new ("<(?!\\/?[biu]>)", 0, 0, &_inner_error0_);
		_tmp3_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp5_ = _tmp3_;
		_tmp3_ = NULL;
		_g_regex_unref0 (notifications_notification_tag_regex);
		notifications_notification_tag_regex = _tmp5_;
		_g_regex_unref0 (_tmp3_);
		_g_regex_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("Notification.vala:57: Invalid regex: %s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
}

static void
notifications_notification_instance_init (NotificationsNotification * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
	self->priv = notifications_notification_get_instance_private (self);
	self->priv->_app_info = NULL;
	self->priv->_priority = G_NOTIFICATION_PRIORITY_NORMAL;
	_tmp0_ = g_strdup (NOTIFICATIONS_NOTIFICATION_OTHER_APP_ID);
	self->priv->_app_id = _tmp0_;
	self->priv->_primary_icon = NULL;
	self->priv->_badge_icon = NULL;
	self->priv->_image = NULL;
}

static void
notifications_notification_finalize (GObject * obj)
{
	NotificationsNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification);
	_g_object_unref0 (self->priv->_app_info);
	_g_hash_table_unref0 (self->priv->_hints);
	self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->_app_icon);
	_g_free0 (self->priv->_app_id);
	_g_free0 (self->priv->_app_name);
	_g_free0 (self->priv->_body);
	_g_free0 (self->priv->_summary);
	_g_object_unref0 (self->priv->_primary_icon);
	_g_object_unref0 (self->priv->_badge_icon);
	_g_object_unref0 (self->priv->_image);
	G_OBJECT_CLASS (notifications_notification_parent_class)->finalize (obj);
}

static GType
notifications_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NotificationsNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notifications_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationsNotification), 0, (GInstanceInitFunc) notifications_notification_instance_init, NULL };
	GType notifications_notification_type_id;
	notifications_notification_type_id = g_type_register_static (G_TYPE_OBJECT, "NotificationsNotification", &g_define_type_info, 0);
	NotificationsNotification_private_offset = g_type_add_instance_private (notifications_notification_type_id, sizeof (NotificationsNotificationPrivate));
	return notifications_notification_type_id;
}

GType
notifications_notification_get_type (void)
{
	static volatile gsize notifications_notification_type_id__volatile = 0;
	if (g_once_init_enter (&notifications_notification_type_id__volatile)) {
		GType notifications_notification_type_id;
		notifications_notification_type_id = notifications_notification_get_type_once ();
		g_once_init_leave (&notifications_notification_type_id__volatile, notifications_notification_type_id);
	}
	return notifications_notification_type_id__volatile;
}

static void
_vala_notifications_notification_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	NotificationsNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification);
	switch (property_id) {
		case NOTIFICATIONS_NOTIFICATION_APP_INFO_PROPERTY:
		g_value_set_object (value, notifications_notification_get_app_info (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_PRIORITY_PROPERTY:
		g_value_set_enum (value, notifications_notification_get_priority (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_HINTS_PROPERTY:
		g_value_set_boxed (value, notifications_notification_get_hints (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_ACTIONS_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, notifications_notification_get_actions (self, &length));
		}
		break;
		case NOTIFICATIONS_NOTIFICATION_APP_ICON_PROPERTY:
		g_value_set_string (value, notifications_notification_get_app_icon (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_APP_ID_PROPERTY:
		g_value_set_string (value, notifications_notification_get_app_id (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_APP_NAME_PROPERTY:
		g_value_set_string (value, notifications_notification_get_app_name (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_BODY_PROPERTY:
		g_value_set_string (value, notifications_notification_get_body (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_SUMMARY_PROPERTY:
		g_value_set_string (value, notifications_notification_get_summary (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_PRIMARY_ICON_PROPERTY:
		g_value_set_object (value, notifications_notification_get_primary_icon (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY:
		g_value_set_object (value, notifications_notification_get_badge_icon (self));
		break;
		case NOTIFICATIONS_NOTIFICATION_IMAGE_PROPERTY:
		g_value_set_object (value, notifications_notification_get_image (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_notifications_notification_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	NotificationsNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification);
	switch (property_id) {
		case NOTIFICATIONS_NOTIFICATION_APP_INFO_PROPERTY:
		notifications_notification_set_app_info (self, g_value_get_object (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_PRIORITY_PROPERTY:
		notifications_notification_set_priority (self, g_value_get_enum (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_HINTS_PROPERTY:
		notifications_notification_set_hints (self, g_value_get_boxed (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_ACTIONS_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			notifications_notification_set_actions (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case NOTIFICATIONS_NOTIFICATION_APP_ICON_PROPERTY:
		notifications_notification_set_app_icon (self, g_value_get_string (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_APP_ID_PROPERTY:
		notifications_notification_set_app_id (self, g_value_get_string (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_APP_NAME_PROPERTY:
		notifications_notification_set_app_name (self, g_value_get_string (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_BODY_PROPERTY:
		notifications_notification_set_body (self, g_value_get_string (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_SUMMARY_PROPERTY:
		notifications_notification_set_summary (self, g_value_get_string (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_PRIMARY_ICON_PROPERTY:
		notifications_notification_set_primary_icon (self, g_value_get_object (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_BADGE_ICON_PROPERTY:
		notifications_notification_set_badge_icon (self, g_value_get_object (value));
		break;
		case NOTIFICATIONS_NOTIFICATION_IMAGE_PROPERTY:
		notifications_notification_set_image (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

